package com.kernelmaft.zanbur

import androidx.compose.runtime.*



object AppState {
	// The index of a group in this list is always equal to its ID
	val groups : State < List <Group> > get () = groupsAsMutable
	private val groupsAsMutable : MutableState < List <Group> > = mutableStateOf ( emptyList () )

	fun setCurrentScene ( groupId : Int , scene : Scene ) {
		groupsAsMutable . value = groupsAsMutable . value . mapIndexed { index , group ->
			if ( index == groupId ) group . copy ( currentScene = scene )
			else group
		}
	}

	fun addGroup ( group : Group ) {
		val newGroups = groupsAsMutable . value . toMutableList ()
		// Wow this is sooo much better than Java
		if ( newGroups . getOrNull ( group . id ) != null ) newGroups . removeAt ( group . id )
		newGroups . add ( group . id , group )
		groupsAsMutable . value = newGroups
	}
}
